/*
 * 쐬: 2007/01/08
 */
package nat.sw;

import java.io.File;
import java.io.FileFilter;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.imageio.spi.IIORegistry;
import javax.imageio.spi.ImageReaderSpi;

/**
 * ̊œǂݍ݉\ȉ摜t@CgqŃtB^NXB
 * ̊ŗp\ImageReaderΉĂ摜tH[}bg
 * t@CgqŃtB^OB
 * ܂Ŋgqł̔ŁAt@C̓e܂ł͊mFȂB
 * gq̑啶/́ASđ啶̕񂵂ΉȂ̂ŒӁB
 * Fbmpt@CɑΉĂ΁Agq".bmp", ".BMP"OKA
 * ".Bmp"".BmP"NG(ǂݍ݉\ȉ摜t@CƔ肵Ȃ)B
 * @see ImageReaderSpi#getFileSuffixes()
 */
public class ImageReaderFileFilter implements FileFilter {
    /** t@Cgq(hbgu.v܂) */
    private String[] m_suffixes;
    
    /**
     * RXgN^
     */
    public ImageReaderFileFilter() {
        // p\ImageReaderSPIAΉĂt@CgqW߂
        IIORegistry registry = IIORegistry.getDefaultInstance();
        Iterator<ImageReaderSpi> spiItr = 
            registry.getServiceProviders(ImageReaderSpi.class, false);
        List<String> suffixList = new LinkedList<String>();
        while(spiItr.hasNext()) {
            suffixList.addAll(Arrays.asList(spiItr.next().getFileSuffixes()));
        }
        // ΉĂt@Cgq̔z(啶Ə2Ȃ̂ŃTCY2{)
        m_suffixes = new String[suffixList.size() * 2];
        int i = 0;
        for(String suffix : suffixList) {
            m_suffixes[i++] = "." + suffix.toLowerCase(); //̊gq
            m_suffixes[i++] = "." + suffix.toUpperCase(); //啶̊gq
        }
    }
    
    /**
     * Ήgq̃t@C肷B
     * ΉgqłAʏ̃t@CłȂt@C(fBNgȂ)
     * Bt@CAǂݍݕsȃt@C͏OB
     * @return ΉgqȂtrueAȊOfalseԂB
     */
    public boolean accept(File file) {
        for(String suffix : m_suffixes) {
            if(file.getPath().endsWith(suffix)) {
                if(file.isFile() && !file.isHidden() && file.canRead()) {
                    return true;
                }
            }
        }
        return false;
    }

}
