/*
 * 쐬: 2007/01/07
 */
package nat.sw;

import java.text.MessageFormat;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * bZ[W̃\[XohǗNXB
 */
public class Messages {
    private static final String BUNDLE_NAME = "nat.sw.ShuffleWallpaper"; //$NON-NLS-1$

    private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle
            .getBundle(BUNDLE_NAME);

    /** G[AxÃbZ[W̃LvVɎgL[̃vtBbNX */
    private static final String CAPTION_KEY_PREFIX = "TrayMessanger.caption.";

    /** G[bZ[W̃LvVɎgL[ */
    public static final String ERROR_CAPTION_KEY = CAPTION_KEY_PREFIX + "error";
    /** xbZ[W̃LvVɎgL[ */
    public static final String WARNING_CAPTION_KEY = CAPTION_KEY_PREFIX + "warning";
    /** 񃁃bZ[W̃LvVɎgL[ */
    public static final String INFORMATION_CAPTION_KEY = CAPTION_KEY_PREFIX + "information";

    public static String getString(String key) {
        try {
            return RESOURCE_BUNDLE.getString(key);
        } catch (MissingResourceException e) {
            return '!' + key + '!';
        }
    }
    
    /**
     * @see nat.sw.MessengerImplementor#getString(nat.sw.Message)
     */
    public static String getString(Message message) {
        String messageKey = message.getMessageKey();
        Object[] args = message.getArguments();
        try {
            String format = Messages.getString(messageKey);
            return MessageFormat.format(format, args);
        } catch(RuntimeException e) {
            Messenger.exceptionThrown(e);
            // Ƃ肠̃bZ[Wo
            StringBuffer buf = new StringBuffer();
            buf.append(messageKey);
            if(args != null) {
                for(int i = 0; i < args.length; i++) {
                    buf.append(", ");
                    buf.append(args[i]);
                }
            }
            return buf.toString();
        }
    }


}
