/*
 * 쐬: 2005/05/04
 */
package nat.sw;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.Rectangle;
import java.awt.RenderingHints;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

/**
 * w肳ꂽ摜t@CA
 * WallpaperEnvironment擾fXNgbvTCYɍ킹
 * TCYύXBMPt@CɕϊWallpaperFixer
 */
public class ResizeAndConvertToBMPWallpaperFixer implements WallpaperFixer {
    /**
     * ϊɎgǎB
     */
    private WallpaperEnvironment m_environment;

    /**
     * @see nat.sw.WallpaperFixer#fix(java.io.File)
     */
    public File fix(File imageFile) throws MessageException {
        BufferedImage orgImage;
        try {
            orgImage = ImageIO.read(imageFile);
        } catch(IOException e) {
            throw new MessageException(
                    "WallpaperFixer.failedToReadImageFile",
                    imageFile);
        }
        
        if(orgImage == null) {
            // w肳ꂽt@C摜̓ǂݍ݂Ɏsꍇ
            throw new MessageException(
                    "WallpaperFixer.notSupportedImageFile",
                    imageFile);
        }
        Dimension destSize = m_environment.getSize();
        Rectangle destRect = m_environment.getBounds();
        
        // ǎ̃TCYA24rbgJ[̉摜obt@
        BufferedImage destImage = new BufferedImage(
                destSize.width, destSize.height, BufferedImage.TYPE_3BYTE_BGR);
        
        Graphics2D g = destImage.createGraphics();
        g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
        g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
        
        // wiFœhԂ
        g.setColor(m_environment.getBackgroundColor());
        g.fillRect(0, 0, destImage.getWidth(), destImage.getHeight());
        
        // cێ悤ɃTCYĉ摜obt@ɏ
        Rectangle dest = calcDestinationRectangle(
                orgImage.getWidth(), orgImage.getHeight(),
                destRect.width, destRect.height
        );
        g.drawImage(orgImage, destRect.x + dest.x, destRect.y + dest.y,
                    dest.width, dest.height, null);
        
        // ǎt@Cɏo
        File destinationFile = m_environment.getFile();
        boolean success = false;
        try {
            success = ImageIO.write(destImage, "bmp", destinationFile);
        } catch(IOException e) {
            throw new MessageException(
                    "WallpaperFixer.failedToWriteImageFile",
                    destinationFile);
        }
        if(!success) {
            // BMPo͂łȂs̏ꍇ͗O𓊂
            throw new MessageException(
                    "ResizeAndConvertToBMPWallpaperFixer.bmpNotSupported");
        }
        return destinationFile;
    }

    /**
     * cێ悤ɉ摜Rs[ʒuvZB
     * @param orgWidth
     * @param orgHeight
     * @param destWidth
     * @param destHeight
     * @return
     */
    private Rectangle calcDestinationRectangle(
            int orgWidth, int orgHeight, int destWidth, int destHeight) {
        // ƍ̔
        double orgRatio = (double)orgWidth / orgHeight;
        double destRatio = (double)destWidth / destHeight;
        Rectangle rect = new Rectangle();
        
        if(orgRatio < destRatio) { // ]̔̕䂪ꍇ
            // ]ɍ킹Ƃ̊g{
            double scale = (double)destHeight / orgHeight;
            // g{Ƃ̓]̕
            double imageWidth = orgWidth * scale;
            // ]̐ݒ
            rect.x = (int)((destWidth - imageWidth) / 2);
            rect.width = (int)imageWidth;
            rect.y = 0;
            rect.height = destHeight;
        } else { // ]̔̕䂪傫ꍇ
            // ]ɍ킹Ƃ̊g{
            double scale = (double)destWidth / orgWidth;
            // g{Ƃ̓]̍
            double imageHeight = orgHeight * scale;
            // ]̐ݒ
            rect.y = (int)((destHeight - imageHeight) / 2);
            rect.height = (int)imageHeight;
            rect.x = 0;
            rect.width = destWidth;
        }      
        return rect;
    }

    public void setWallpaperEnvironment(WallpaperEnvironment environment) {
        m_environment = environment;
    }
}
