/*
 * 쐬: 2005/05/03 
 */
package nat.sw;

import java.io.File;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

/**
 * @author naotsugu
 * ǎ_ɕύXNX
 */
public class ShuffleWallpaper implements Runnable {
	
	/** ǎ_Ɍ߂R|[lg */
	private WallpaperShuffler m_wallpaperShuffler = null;
	/** ǎ̃TCYtH[}bgȂǂύXR|[lg */
	private WallpaperFixer m_wallpaperFixer = null;
	/** ǎύXsR|[lg */
	private WallpaperChanger m_wallpaperChanger = null;
	
    /** \Ăǎt@C */
    private File m_currentImageFile = null;
    
    private List<ShuffleWallpaperListener> m_shuffleWallpaperListenerList =
        new LinkedList<ShuffleWallpaperListener>();
	
    /**
     * ǎ_ɕύX鏈sB
     */
    public void change() {
        try {
            Messenger.showInformation("ShuffleWallpaper.searchWallpapers");
            File imageFile = m_wallpaperShuffler.getNextWallpaper();
            change(imageFile);
        } catch(MessageException e) {
            Messenger.showError(e.getErrorMessage());
        } catch(Exception e) {
            String message = e.getMessage();
            Messenger.exceptionThrown(e);
            Messenger.showError(new Message("ShuffleWallpaper.exception", message));
        }
    }

    /**
     * 񓯊ŕǎ_ɕύXB
     * ̃\bhĂԂƁAǎύXIO(ǎύXXbh
     * N)Ƀ\bhԂB
     */
    public void changeAsync() {
        new Thread(this).start();
    }
    
    /**
     * (Runnablep)ǎ_ɕύXB
     */
    public void run() {
        change();
    }
    
    /**
     * ǎw肳ꂽt@CɕύXB
     */
    public synchronized void change(File imageFile) {
        Messenger.showInformation("ShuffleWallpaper.wallpaperChanging");
        m_currentImageFile = imageFile;
        try {
            File wallpaperFile = m_wallpaperFixer.fix(imageFile);
            m_wallpaperChanger.change(wallpaperFile);
            Messenger.showInformation(
                    "ShuffleWallpaper.wallpaperChanged", imageFile.getName());                
        } catch(MessageException e) {
            Messenger.showError(e.getErrorMessage());
        } catch(Exception e) {
            String message = e.getMessage();
            Messenger.exceptionThrown(e);
            Messenger.showError(new Message("ShuffleWallpaper.exception", message));
        }
        fireWallpaperChanged();
    }
    
    /**
     * 񓯊ŕǎw肳ꂽt@CɕύXB
     * ̃\bhĂԂƁAǎύXIO(ǎύXXbh
     * N)Ƀ\bhԂB
     * @param imageFile
     */
    public void changeAsync(File imageFile) {
        new ChangeWallpaperThread(imageFile).start();
    }
    
    /**
     * ǎύXXbh
     */
    class ChangeWallpaperThread extends Thread {
        private File m_imageFile;
        public ChangeWallpaperThread(File imageFile) {
            m_imageFile = imageFile;
        }
        public void run() {
            change(m_imageFile);
        }
    }    
    
    /**
     * @return wallpaperChanger ߂܂B
     */
    public WallpaperChanger getWallpaperChanger() {
        return m_wallpaperChanger;
    }
    /**
     * @param wallpaperChanger wallpaperChanger ݒB
     */
    public void setWallpaperChanger(WallpaperChanger wallpaperChanger) {
        m_wallpaperChanger = wallpaperChanger;
    }
    /**
     * @return wallpaperFixer ߂܂B
     */
    public WallpaperFixer getWallpaperFixer() {
        return m_wallpaperFixer;
    }
    /**
     * @param wallpaperFixer wallpaperFixer ݒB
     */
    public void setWallpaperFixer(WallpaperFixer wallpaperFixer) {
        m_wallpaperFixer = wallpaperFixer;
    }
    /**
     * @return wallpaperShuffler ߂܂B
     */
    public WallpaperShuffler getWallpaperShuffler() {
        return m_wallpaperShuffler;
    }
    /**
     * @param wallpaperShuffler wallpaperShuffler ݒB
     */
    public void setWallpaperShuffler(WallpaperShuffler wallpaperShuffler) {
        m_wallpaperShuffler = wallpaperShuffler;
    }

	/**
	 * main֐B
	 * @param args
	 */
    public static void main(String[] args) {
        ShuffleWallpaperContainer container = null;
        try {
            container = new ShuffleWallpaperContainer();
        } catch(MessageException e) {
            Messenger.exceptionThrown(e);
            Messenger.showError(e.getErrorMessage());
        }
        container.getShuffleWallpaper().change();
        System.exit(0);
    }

    /**
     * \Ăǎt@CԂB
     * @return \Ăǎt@C
     */
    public File getCurrentImageFile() {
        return m_currentImageFile;
    }

    public void addShuffleWallpapaerListener(ShuffleWallpaperListener l) {
        m_shuffleWallpaperListenerList.add(l);
    }
    
    public void removeShuffleWallpaperListener(ShuffleWallpaperListener l) {
        m_shuffleWallpaperListenerList.remove(l);
    }
    
    private void fireWallpaperChanged() {
        Iterator<ShuffleWallpaperListener> itr = m_shuffleWallpaperListenerList.iterator();
        while(itr.hasNext()) {
            ShuffleWallpaperListener l = itr.next();
            l.wallpaperChanged(
                    new ShuffleWallpaperEvent(this, m_currentImageFile));
        }
    }
    
}
