/*
 * 쐬: 2006/07/16
 */
package nat.sw;

import java.io.IOException;

/**
 * ShuffleWallpaper̃R|[lgێNX
 */
public class ShuffleWallpaperContainer {
    /** ݒt@C */
    private static final String CONFIG_FILE_NAME = "configuration.xml"; 
    
    private ShuffleWallpaper m_shuffleWallpaper;
    private Configuration m_configuration;
    
    /**
     * RXgN^B
     * sȂB
     * @throws MessageException ɎsƂ
     */
    public ShuffleWallpaperContainer() throws MessageException {
        Messenger.setMessengerImplementor(new SystemErrMessengerImplementor());        

        try {
            // ǎIWallpaperShuffler̐ݒ
            m_configuration = Configuration.load(CONFIG_FILE_NAME);
            if(m_configuration.isUseImageReaderFileFilter()) {
                WallpaperDirectory.setImageFileFilter(new ImageReaderFileFilter());
            } else {
                WallpaperDirectory.setImageFileFilter(null);
            }
        } catch(IOException e) {
            throw new MessageException(
                    "Config.failedToReadPropertyFile", CONFIG_FILE_NAME);
        }
    }
    
    /**
     * ShuffleWallpaper ԂB
     * @return shuffleWallpaper
     */
    public ShuffleWallpaper getShuffleWallpaper() {
        if(m_shuffleWallpaper == null) {
            m_shuffleWallpaper = new ShuffleWallpaper();

            // ̕ǎ肷WallpaperShuffer̐ݒ
            WallpaperShuffler shuffler = new WallpaperShuffler(this);
            m_shuffleWallpaper.setWallpaperShuffler(shuffler);
            
            // ǎ̃TCYȂǂ̕ϊWallpaperFixer̐ݒ
            WindowsWallpaperEnvironment env = new WindowsWallpaperEnvironment();
            env.setConfiguration(getConfiguration());
            ResizeAndConvertToBMPWallpaperFixer fixer =
                new ResizeAndConvertToBMPWallpaperFixer();
            fixer.setWallpaperEnvironment(env);
            m_shuffleWallpaper.setWallpaperFixer(fixer);
            
            // ǎύXWallpaperChanger̐ݒ
            ExecWallpaperChanger changer = new ExecWallpaperChanger();
            changer.setCommand(getConfiguration().getCommand());
            m_shuffleWallpaper.setWallpaperChanger(changer);
        }
        return m_shuffleWallpaper;
    }

    /**
     * Configuration ԂB
     * @return wallpaperConfiguration
     */
    public Configuration getConfiguration() {
        return m_configuration;
    }
    
    /**
     * ConfigurationۑB
     * @throws IOException
     */
    public void saveConfiguration() throws MessageException {
        try {
            getConfiguration().save(CONFIG_FILE_NAME);
        } catch(IOException ex) {
            throw new MessageException(
                    "Config.failedToWritePropertyFile",
                    CONFIG_FILE_NAME);
        }
    }
}
