/*
 * 쐬: 2007/01/03
 */
package nat.sw;

import java.io.File;
import java.io.FileFilter;
import java.util.LinkedList;
import java.util.List;

/**
 * ǎi[fBNg\NX
 */
public class WallpaperDirectory {
    /** 摜t@C𔻒肷tB^ */
    private static FileFilter s_imageFileFilter = new ImageReaderFileFilter(); 
    /** fBNg𔻒肷tB^ */
    private static FileFilter s_dirFilter = new DirectoryFileFilter();
    
    /** fBNgւ̃pX */
    private String m_path;
    
    /** TufBNggȂtrueBȊOfalse */
    private boolean m_useSubDirectory = false;
    
    /** ̕ǃfBNggȂtrueBȊOfalse */
    private boolean m_enable = true;

    /**
     * enable ԂB
     * @return enable
     */
    public boolean isEnable() {
        return m_enable;
    }

    /**
     * enable ݒ肷B
     * @param enable enable
     */
    public void setEnable(boolean enable) {
        m_enable = enable;
    }

    /**
     * path ԂB
     * @return path
     */
    public String getPath() {
        return m_path;
    }

    /**
     * path ݒ肷B
     * @param path path
     */
    public void setPath(String path) {
        m_path = path;
    }

    /**
     * useSubDirectory ԂB
     * @return useSubDirectory
     */
    public boolean isUseSubDirectory() {
        return m_useSubDirectory;
    }

    /**
     * useSubDirectory ݒ肷B
     * @param useSubDirectory useSubDirectory
     */
    public void setUseSubDirectory(boolean useSubDirectory) {
        m_useSubDirectory = useSubDirectory;
    }

    /**
     * vpeBpathɎw肳ꂽfBNgȉ̉摜t@CW߁A
     * w肳ꂽListɊi[B
     * vpeBuseSubDirectorytruêƂ̂
     * TufBNg̃t@CW߂B
     * vpeBenablefalseȂ牽ȂB
     * @return
     * @throws MessageException
     */
    public void collectFiles(List<File> list) throws MessageException {
        if(!m_enable) {
            return; // ̕ǎfBNg͎gȂ
        }
        File wallpaperDirectory = new File(m_path);
        if(!wallpaperDirectory.isDirectory()) {
            // fBNgǂݍݎs
            throw new MessageException(
                    "DirectoryWallpaperShuffler.failedToReadDirectory",
                    wallpaperDirectory);
        }
        
        collectFiles(wallpaperDirectory, list);
    }
    
    /**
     * fBNgdirectoryȉ̉摜t@CW߁AfileListɊi[B
     * @param directory
     * @param fileList
     * @throws MessageException
     */
    private void collectFiles(File directory, List<File> fileList) throws MessageException {
        // 摜t@Co
        File[] files = directory.listFiles(s_imageFileFilter);
        for(File file : files) {
            fileList.add(file);
        }
        if(m_useSubDirectory) {
            //TufBNggݒ̏ꍇA
            //TufBNgȉ̃t@CW߂
            File[] dirs = directory.listFiles(s_dirFilter);
            for(File dir : dirs) {
                collectFiles(dir, fileList);
            }   
        }
    }

    /**
     * 摜t@Č(ɕ\ǎ̌␔)ԂB
     * @return
     * @throws MessageException
     */
    public int getNumberOfWallpaper() throws MessageException {
        List<File> list = new LinkedList<File>();
        collectFiles(list);
        return list.size();
    }

    /**
     * WallpaperDirectorỹRs[ԂB
     * @return
     */
    public WallpaperDirectory copy() {
        WallpaperDirectory copy = new WallpaperDirectory();
        copy.setEnable(isEnable());
        copy.setUseSubDirectory(isUseSubDirectory());
        copy.setPath(getPath());
        return copy;
    }
    
    /**
     * 摜t@CW߂Ƃ̃tB^w肷B
     * @param imageFileFilter
     */
    public static void setImageFileFilter(FileFilter imageFileFilter) {
        s_imageFileFilter = imageFileFilter;
    }
}
