/*
 * 쐬: 2005/05/05
 */
package nat.sw.tray;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import javax.imageio.spi.IIORegistry;
import javax.imageio.spi.ImageReaderSpi;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.UIManager;

import nat.sw.MessageException;
import nat.sw.Messages;
import nat.sw.Messenger;
import nat.sw.ShuffleWallpaperEvent;
import nat.sw.ShuffleWallpaperListener;

import org.jdesktop.jdic.tray.SystemTray;
import org.jdesktop.jdic.tray.TrayIcon;

/**
 * ShuffleWallpaper̃VXegC\NX
 */
public class ShuffleWallpaperTray extends TrayIcon
implements ShuffleWallpaperListener{

    /** ShuffleWallpaper̃R|[lgێRei */
    private ShuffleWallpaperTrayContainer m_container;

    /** t@CI_CAO */
    private JFileChooser m_fileChooser = new JFileChooser();

    /**
     * ŌɕǎƂ́A擪ɐݒ肳ꂽǎfBNgB
     * ǎfBNgςĂ΁AVǎfBNg
     * JgfBNgɂB
     * ȊÓAOɎǎ̂fBNgB
     */
    private String m_lastFirstPath = null; 
    
    
    /**
     * VXegCɓo^TrayIcon̐
     * @param container
     */
    public ShuffleWallpaperTray(ShuffleWallpaperTrayContainer container) {
        super(container.getTrayImageIcon(),
                Messages.getString("ShuffleWallpaperTray.caption"),
                container.getTrayPopupMenu());
        setIconAutoSize(true);
        addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                changeWallpaper();
            }
        }); // gCACRNbNƂ̏

        m_container = container;
        m_container.getShuffleWallpaper().addShuffleWallpapaerListener(this);
        
    }
    
    /**
     * Npmain\bhB
     * @param args
     */
	public static void main(String[] args) {
	    // OSŗLLook&Feelɐݒ
        try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.setProperty("javax.swing.adjustPopupLocationToFit", "false");
        
        ShuffleWallpaperTrayContainer container = null; 
        try {
            container = new ShuffleWallpaperTrayContainer();            
        } catch(MessageException e) {
            Messenger.exceptionThrown(e);
            Messenger.showError(e.getErrorMessage());
        }
        
        try {
            SystemTray.getDefaultSystemTray().addTrayIcon(
                    container.getShuffleWallpaperTray());
            
            // ԊuShuffleWallpaperĂԃXbhN
            IntervalShuffleThreadManager threadManager =
                container.getIntervalShuffleThreadManager();
            if(threadManager.getConfiguration().isIntervalRunning()) {
                threadManager.start();                
            } else {
                // ԂɕǎύXȂꍇ͍ŏ̈񂾂ǎύX
                new Thread(threadManager.getShuffleWallpaper()).start();
            }
            
        } catch(Exception e) {
            Messenger.exceptionThrown(e);
        }
    }

    /**
     * ǎύXɌĂ΂Cxgʒm\bhB
     */
    public void wallpaperChanged(ShuffleWallpaperEvent event) {
        StringBuffer tooltip = new StringBuffer();
        tooltip.append(Messages.getString("ShuffleWallpaperTray.caption"));
        tooltip.append('\n');
        tooltip.append(event.getImageFile().getName());
        setToolTip(tooltip.toString());
    }
    
    /**
     * ǎύXB
     * ǎύX񓯊Ɏs邽߁A
     * ̃\bhĂԂƁAɕԂB
     *@
     */
    public void changeWallpaper() {
        m_container.getShuffleWallpaper().changeAsync();
    }
    
    /**
     * ShuffleWallpapeȑI
     */
    public void exit() {
        m_container.getIntervalShuffleThreadManager().stop();
        try {
            m_container.saveConfiguration();
        } catch(MessageException ex) {
            Messenger.exceptionThrown(ex);
            Messenger.showError(ex.getErrorMessage());
        }
        SystemTray.getDefaultSystemTray().removeTrayIcon(this);
        System.exit(0);
    }

    public void tryWallpaper() {
        // 擪ɐݒ肳ĂǎfBNgςĂ΁A
        // JgfBNgǎfBNgɂB
        String firstPath = m_container.getConfiguration().
            getWallpaperDirectoryCollection().
            getFirstWallpaperDirectory().getPath();
        if(firstPath != null) {
            if(!firstPath.equals(m_lastFirstPath)) {
                m_fileChooser.setCurrentDirectory(new File(firstPath));
            }
        }
        int option = m_fileChooser.showOpenDialog(null);
        if(option == JFileChooser.APPROVE_OPTION) {
            m_container.getShuffleWallpaper().changeAsync(
                    m_fileChooser.getSelectedFile());
            m_lastFirstPath = firstPath;
        }
    }
    
    
    /**
     * o[W_CAO̕\
     */
    public void showVersionDialog() {
        StringBuffer suffixesBuf = new StringBuffer();
        String[] suffixes = getSupportedImageFileSuffixes();
        for(String suffix : suffixes) {
            suffixesBuf.append(suffix);
            suffixesBuf.append(' ');
        }
        JOptionPane.showMessageDialog(
                null, Messages.getString("About.message") + suffixesBuf.toString(),
                Messages.getString("About.title"),
                JOptionPane.INFORMATION_MESSAGE, m_container.getTrayImageIcon());
    }

    /**
     * ΉĂ摜tH[}bg̊gq̔zԂB
     * @return
     */
    private String[] getSupportedImageFileSuffixes() {
        IIORegistry registry = IIORegistry.getDefaultInstance();
        Iterator<ImageReaderSpi> spiItr = 
            registry.getServiceProviders(ImageReaderSpi.class, false);
        List<String> suffixList = new LinkedList<String>();
        while(spiItr.hasNext()) {
            suffixList.addAll(Arrays.asList(spiItr.next().getFileSuffixes()));
        }
        return suffixList.toArray(new String[0]);
    }

    /**
     * ݒ_CAO̕\
     * @param e
     */
    public void showConfigDialog() {
        m_container.getConfigDialog().open();
    }

}
