/*
 * 쐬: 2006/07/16
 */
package nat.sw.tray;

import java.awt.event.ActionEvent;

import javax.swing.AbstractButton;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JPopupMenu;

import nat.sw.MessageException;
import nat.sw.Messages;
import nat.sw.Messenger;
import nat.sw.MessengerImplementor;
import nat.sw.ShuffleWallpaperContainer;
import nat.sw.tray.config.ConfigDialog;


/**
 * ShuffleWallpapaerTraỹR|[lgێNX
 */
public class ShuffleWallpaperTrayContainer extends ShuffleWallpaperContainer {
    private IntervalShuffleThreadManager m_intervalShuffleThreadManager;
    private ConfigDialog m_cofingDialog;
    private ImageIcon m_trayImageIcon;
    private ShuffleWallpaperTray m_shuffleWallpapaerTray;
    private JPopupMenu m_trayPopupMenu;
    
    /**
     * RXgN^B
     * @throws MessageException
     */
    public ShuffleWallpaperTrayContainer() throws MessageException {
        super();
        MessengerImplementor messenger = new TrayMessanger(
                getShuffleWallpaperTray());
        Messenger.setMessengerImplementor(messenger);
    }

    /**
     * ԊuShuffleWallpaperĂԃXbh̊ǗsȂ
     * IntervalShuffleThreadManager ԂB
     * @return intervalShuffleThreadManager
     */
    public IntervalShuffleThreadManager getIntervalShuffleThreadManager() {
        if(m_intervalShuffleThreadManager == null) {
            m_intervalShuffleThreadManager = new IntervalShuffleThreadManager();
            m_intervalShuffleThreadManager.setConfiguration(getConfiguration());
            m_intervalShuffleThreadManager.setShuffleWallpaper(getShuffleWallpaper());
        }
        return m_intervalShuffleThreadManager;
    }
    
    /**
     * ݒ_CAȌ
     */
    public ConfigDialog getConfigDialog() {
        if(m_cofingDialog == null) {
            m_cofingDialog = new ConfigDialog(this);
        }
        return m_cofingDialog;
    }
    
    /**
     * gCACRɕ\|bvAbvj[̎擾
     */
    public JPopupMenu getTrayPopupMenu() {
        if(m_trayPopupMenu == null) {
            m_trayPopupMenu = new JPopupMenu();
    
            // ǎύX
            ActionSupport shuffleWallpaperAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    getShuffleWallpaperTray().changeWallpaper();
                }
            };
            shuffleWallpaperAction.setName(Messages.getString("ShuffleWallpaperAction.name"));
            m_trayPopupMenu.add(shuffleWallpaperAction);
            
            // ĕ\
            m_trayPopupMenu.add(new RedisplayAction(this));
            
            // ǎ
            ActionSupport tryWallpaperAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    getShuffleWallpaperTray().tryWallpaper();
                }
            };
            tryWallpaperAction.setName(Messages.getString("TryWallpaperAction.name"));
            m_trayPopupMenu.add(tryWallpaperAction);
    
            // ԂɕǎύX
            ActionSupport invertAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    AbstractButton button = (AbstractButton)e.getSource();
                    getConfiguration().setIntervalRunning(button.isSelected());
                    if(button.isSelected()) {
                        getIntervalShuffleThreadManager().start();            
                    } else {
                        getIntervalShuffleThreadManager().stop();            
                    }
                }
            };
            invertAction.setName(Messages.getString("InvertIntervalShuffleAction.name"));
            JCheckBoxMenuItem checkboxMenu = new JCheckBoxMenuItem(invertAction);
            checkboxMenu.setSelected(getConfiguration().isIntervalRunning());
            m_trayPopupMenu.add(checkboxMenu);
            
            // ݒ
            ActionSupport openConfigAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    getShuffleWallpaperTray().showConfigDialog();
                }
            };
            openConfigAction.setName(
                    Messages.getString("OpenConfigDialogAction.name"));
            m_trayPopupMenu.add(openConfigAction);
            
            // o[W
            ActionSupport showVersionAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    getShuffleWallpaperTray().showVersionDialog();
                }
            };
            showVersionAction.setName(
                    Messages.getString("ShowVersionAction.name"));
            m_trayPopupMenu.add(showVersionAction);
            
            // I
            ActionSupport exitAction = new ActionSupport() {
                public void actionPerformed(ActionEvent e) {
                    getShuffleWallpaperTray().exit();
                }
            };
            exitAction.setName(Messages.getString("ExitAction.name"));
            m_trayPopupMenu.add(exitAction);
        }
        return m_trayPopupMenu;
    }

    /**
     * ShufflwWallpaperTrayԂB
     * @return trayIcon
     */
    public ShuffleWallpaperTray getShuffleWallpaperTray() {
        if(m_shuffleWallpapaerTray == null) {
            m_shuffleWallpapaerTray = new ShuffleWallpaperTray(this);
        }
        return m_shuffleWallpapaerTray;
    }

    /**
     * @return gCɕ\摜ACRԂB
     */
    public ImageIcon getTrayImageIcon() {
        if(m_trayImageIcon == null) {
            m_trayImageIcon = new ImageIcon("sw.gif");            
        }
        return m_trayImageIcon;
    }
}
