/*
 * 쐬: 2005/06/11
 */
package nat.sw.tray;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.Date;

import nat.sw.Message;
import nat.sw.MessageException;
import nat.sw.Messages;
import nat.sw.ResouceBundleMessengerImplmentor;

import org.jdesktop.jdic.tray.TrayIcon;


/**
 * VXegCɃbZ[W\MessangerNXB
 */
public class TrayMessanger extends ResouceBundleMessengerImplmentor {
    /** bZ[W\ɎggCACR */
    private TrayIcon m_trayIcon = null;

    /**
     * RXgN^
     * @param trayIcon bZ[W\ɎgTrayIcon
     */
    public TrayMessanger(TrayIcon trayIcon) {
        m_trayIcon = trayIcon;
    }
    
    public void showError(Message message) {
        m_trayIcon.displayMessage(
                getErrorCaption(),
                Messages.getString(message), 
                TrayIcon.ERROE_MESSAGE_TYPE);
    }

    public void showWarning(Message message) {
        m_trayIcon.displayMessage(
                getWarningCaption(),
                Messages.getString(message),
                TrayIcon.WARNING_MESSAGE_TYPE);
    }

    public void showInformation(Message message) {
        m_trayIcon.displayMessage(
                getInformationCaption(),
                Messages.getString(message),
                TrayIcon.INFO_MESSAGE_TYPE);
    }

    /**
     * t@CɗO̓eo͂B
     * @see nat.sw.MessengerImplementor#exceptionThrown(java.lang.Exception)
     */
    public void exceptionThrown(Exception e) {
        SimpleDateFormat format = new SimpleDateFormat("yyyyMMdd-HHmmssSSS");
        String errFileName = "err" + format.format(new Date()) + ".log";
        PrintWriter writer = null;
        try {
            writer = new PrintWriter(errFileName);
        } catch(FileNotFoundException e2) {
            e2.printStackTrace();
            e.printStackTrace();
            return;
        }
        if(e instanceof MessageException) {
            writer.println(
                    Messages.getString(((MessageException)e).getErrorMessage()));
        }
        writer.println(e.getMessage());
        e.printStackTrace(writer);
        writer.close();
    }
}
