/*
 * 쐬: 2005/05/22
 */
package nat.sw.tray.config;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GraphicsEnvironment;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSlider;
import javax.swing.SwingConstants;

import nat.sw.MessageException;
import nat.sw.Messages;
import nat.sw.Messenger;
import nat.sw.Configuration;
import nat.sw.tray.ShuffleWallpaperTrayContainer;

/**
 * ݒp_CAO
 */
public class ConfigDialog extends JDialog {
    /** OK/Cancel{^\yC */
    private JPanel m_buttonPane = new JPanel();
    
    /** ǎfBNgݒ肷pl */
    private WallpaperDirectoryTablePanel m_wallpaperDirectoryPanel;
    
    /** wiFIԂ߂̃tB[h */
    private ColorChooserField m_backgroundColorField;
    /** ǎύX̎ԊԊu͂邽߂̃XC_[ */
    private ShuffleIntervalSlider m_shuffleIntervalSlider;
    
    /** OK{^ */
    private JButton m_okButton;
    /** LZ{^ */
    private JButton m_cancelButton;

    private ShuffleWallpaperTrayContainer m_container;
    
    /** 
     * init()Ń_CAOς݂ǂB
     * ς݂ȂtrueBȂfalse
     */
    private boolean m_initialized = false;
    
    /**
     * RXgN^
     */
    public ConfigDialog(ShuffleWallpaperTrayContainer container) {
        super();
        m_container = container;
    }
    
    private WallpaperDirectoryTablePanel getWallpaperDirectoryPanel() {
        if(m_wallpaperDirectoryPanel == null) {
            m_wallpaperDirectoryPanel = new WallpaperDirectoryTablePanel();
        }
        return m_wallpaperDirectoryPanel;
    }
    
    private ColorChooserField getBackgroundColorField() {
        if(m_backgroundColorField == null) {
            m_backgroundColorField = new ColorChooserField(
                    Messages.getString("ConfigDialog.colorChooser.change"),
                    Messages.getString("ConfigDialog.colorChooser.selectBackgroundColor"));
        }
        return m_backgroundColorField;
    }
    
    private SliderWithValue getShuffleIntervalSlider() {
        if(m_shuffleIntervalSlider == null) {
            m_shuffleIntervalSlider = new ShuffleIntervalSlider();
            m_shuffleIntervalSlider.setUnit(
                    Messages.getString("ConfigDialog.shuffleIntervalSlider.unit"));
            m_shuffleIntervalSlider.setZeroValueLabel(
                    Messages.getString("ConfigDialog.shuffleIntervalSlider.zeroValueLabel"));
            JSlider slider = m_shuffleIntervalSlider.getSlider();
            slider.setMinimum(0);
            slider.setMaximum(120);
            slider.setMajorTickSpacing(10);
            slider.setMinorTickSpacing(1);
            slider.setPaintTicks(true);
            slider.setPaintLabels(true);
        }
        return m_shuffleIntervalSlider;
    }
    
    /**
     * B
     * Rg[̔zuLZ{^̃CxgݒsB
     */
    private void init() {
        setTitle(Messages.getString("ConfigDialog.title"));
        setResizable(false); // TCYύXsɂ(^Cgo[̃ACR)
        JComponent mainPane = initMainPane();
        getContentPane().setLayout(new BorderLayout());
        getContentPane().add(mainPane, BorderLayout.CENTER);
        
        m_buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
        m_okButton = new JButton(Messages.getString("ConfigDialog.ok"));
        m_buttonPane.add(m_okButton);
        m_cancelButton = new JButton(Messages.getString("ConfigDialog.cancel"));
        m_buttonPane.add(m_cancelButton);
        getContentPane().add(m_buttonPane, BorderLayout.SOUTH);
        
        m_cancelButton.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        setVisible(false);
                    }
                });
        m_okButton.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        updateConfiguration();
                        setVisible(false);
                    }
                });
        
        pack();
        
        // ʒɈړ
        Point point = GraphicsEnvironment
        				.getLocalGraphicsEnvironment().getCenterPoint();
        point.x -= getWidth() / 2;
        point.y -= getHeight() / 2;
        setLocation(point);
        
        m_initialized = true;
    }
    
    /**
     * _CAOJB
     * ̂ƂAݒ肳ꂽBindergāA݂̐ݒlRg[ɐݒ肷B
     */
    public void open() {
        if(!m_initialized) {
            init();
        }
        loadConfiguration();
        setVisible(true);
    }

    private JComponent initMainPane() {
        JPanel mainPanel = new JPanel();
        GridBagLayout gbl = new GridBagLayout();
        mainPanel.setLayout(gbl);
        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.insets = new Insets(5, 5, 0, 5);

        addJLabelAndJComponentToJPanel(mainPanel, gbl,
                new JLabel(
                        Messages.getString("ConfigDialog.wallpaperDirectoryLabel"),
                        SwingConstants.RIGHT),
                getWallpaperDirectoryPanel());
       
        addJLabelAndJComponentToJPanel(mainPanel, gbl,
                new JLabel(
                        Messages.getString("ConfigDialog.backgroundColorLabel"),
                        SwingConstants.RIGHT),
                getBackgroundColorField());
        
        addJLabelAndJComponentToJPanel(mainPanel, gbl,
                new JLabel(
                        Messages.getString("ConfigDialog.shuffleIntervalLabel"),
                        SwingConstants.RIGHT),
                getShuffleIntervalSlider());
        
        return mainPanel;
    }
    
    private void addJLabelAndJComponentToJPanel(
            JPanel panel, GridBagLayout gbl,
            JLabel label, JComponent component) {
        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.insets = new Insets(5, 5, 0, 5);
        
        gbl.setConstraints(label, c);
        panel.add(label);

        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gbl.setConstraints(component, c);
        panel.add(component);
    }
    
    /**
     * ݒ_CAOJƂ̏B
     * ݒ_CAȌlAPropertiesWallpaperConfigurationǂݍށB
     */
    private void loadConfiguration() {
        getWallpaperDirectoryPanel().setWallpaperDirectoryCollection(
                getConfiguration().getWallpaperDirectoryCollection().copy());
        getBackgroundColorField().setColor(
                getConfiguration().getBackgroundColor());
        getShuffleIntervalSlider().setValue(
                (int)getConfiguration().getShuffleIntervalMinute());
    }
    
    /**
     * ݒ_CAOOK{^ꂽƂ̏B
     * ݒ_CAOɓ͂ꂽlAPropertiesWallpaperConfigurationɐݒ肷B
     */
    private void updateConfiguration() {
        getConfiguration().setWallpaperDirectoryCollection(
                getWallpaperDirectoryPanel().getWallpaperDirectoryCollection());
        getConfiguration().setBackgroundColor(
                getBackgroundColorField().getColor());
        getConfiguration().setShuffleIntervalMinute(
                getShuffleIntervalSlider().getValue());
        try {
            m_container.saveConfiguration();
        } catch(MessageException e) {
            Messenger.exceptionThrown(e);
            Messenger.showError(e.getErrorMessage());
            return;
        }
        if(getConfiguration().isIntervalRunning()) {
            m_container.getIntervalShuffleThreadManager().start();            
        } else {
            new Thread(m_container.getShuffleWallpaper()).start();
        }
    }

    private Configuration getConfiguration() {
        return m_container.getConfiguration();
    }
}
