/*
 * 쐬: 2007/01/07
 */
package nat.sw.tray.config;

import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.AbstractCellEditor;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.table.TableCellEditor;

import nat.sw.Messages;

/**
 * fBNg͂邽߂̃ZGfB^
 */
public class DirectoryCellEditor extends AbstractCellEditor 
implements TableCellEditor {
    
    private JFileChooser m_fileChooser;
    private JPanel m_panel;
    private JTextField m_textField;
    private JButton m_button;
    
    public DirectoryCellEditor() {
        m_fileChooser = new JFileChooser();
        m_fileChooser.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        
        m_button = new JButton(Messages.getString("DirectoryCellEditor.button"));
        
        m_textField = new JTextField();
        
        m_panel = new JPanel();
        m_panel.setLayout(new BorderLayout());
        m_panel.add(m_textField, BorderLayout.CENTER);
        m_panel.add(m_button, BorderLayout.EAST);
        
        m_button.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                showFileChooser();
            }
        });
    }
    
    public Component getTableCellEditorComponent(JTable table, Object value,
            boolean isSelected, int row, int column) {
        m_textField.setText(value.toString());
        return m_panel;
    }

    public Object getCellEditorValue() {
        return new File(m_textField.getText());
    }

    private void showFileChooser() {
        m_fileChooser.setCurrentDirectory(new File(m_textField.getText()));
        int option = m_fileChooser.showDialog(
                m_panel,
                Messages.getString("ConfigDialog.fileField.select"));
        if(option == JFileChooser.APPROVE_OPTION) {
            m_textField.setText(
                    m_fileChooser.getSelectedFile().toString());
            
        }
    }
}
