/*
 * 쐬: 2005/06/19
 */
package nat.sw.tray.config;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;
import javax.swing.JTextField;

import nat.sw.Messages;

/**
 * t@C̓tB[hB
 */
public class FileField extends JPanel {
    private JTextField m_textField = new JTextField();
    private JButton m_referButton;
    private JFileChooser m_fileChooser = new JFileChooser();
    private String m_approveButtonText; 
    
    /**
     * RXgN^
     *
     */
    public FileField() {
        this(Messages.getString("ConfigDialog.fileField.refer"),
                Messages.getString("ConfigDialog.fileField.select"));        
    }
    
    /**
     * RXgN^
     * @param referButtonName Qƃ{^ɕ\镶
     * @param approveButtonName t@CI_CAȎIp{^ɕ\镶
     */
    public FileField (String referButtonName, String approveButtonText) {
        m_referButton = new JButton(referButtonName);
        m_approveButtonText = approveButtonText;
        init();
    }
    
    private void init() {
        setLayout(new BorderLayout());
        add(m_textField, BorderLayout.CENTER);
        add(m_referButton, BorderLayout.EAST);
        m_referButton.addActionListener(
                new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        openFileChooser();
                    }
                });
    }
    
    private void openFileChooser() {
        File current = new File(m_textField.getText());
        m_fileChooser.setCurrentDirectory(current);
        int option = m_fileChooser.showDialog(this, m_approveButtonText);
        if(option == JFileChooser.APPROVE_OPTION) {
            m_textField.setText(m_fileChooser.getSelectedFile().getPath());
        }
    }
    
    /**
     * tB[hɓ͂ꂽt@CԂB
     * @return
     */
    public String getFileName() {
        return m_textField.getText();
    }
    
    /**
     * t@CtB[hɐݒ肷B
     * @param fileName
     */
    public void setFileName(String fileName) {
        m_textField.setText(fileName);
    }
    
    /**
     * t@CI_CAOԂB
     * @return
     */
    public JFileChooser getFileChooser() {
        return m_fileChooser;
    }
    /**
     * t@C̓tB[hԂB
     * @return
     */
    public JTextField getTextField() {
        return m_textField;
    }
}
